## ros-iron-ecl-time-lite 1.2.0

=== CMakeLists.txt ===
##############################################################################
# Cmake
##############################################################################

cmake_minimum_required(VERSION 3.5)
project(ecl_time_lite)

##############################################################################
# Find Packages
##############################################################################

# Turn -isystem off. Actually like to see warnings from underlying packages
# and regardless, have run into trouble because of the ordering it induces.
set(CMAKE_NO_SYSTEM_FROM_IMPORTED TRUE)

find_package(ament_cmake_ros REQUIRED)
find_package(ecl_build REQUIRED)
find_package(ecl_config REQUIRED)
find_package(ecl_errors REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

ament_package_xml()
ecl_enable_cxx14_compiler()
ecl_enable_cxx_warnings()

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include)

# This configures ECL_PLATFORM_TIME_LIBRARIES and
# other ECL_PLATFORM_HAS_XXX flags
ecl_detect_timers()

##############################################################################
# Sources
##############################################################################

add_subdirectory(include)
add_subdirectory(src)

##############################################################################
# Exports
##############################################################################

# Downstream CMake3 compatibility 
ament_export_targets(HAS_LIBRARY_TARGET ${PROJECT_NAME})
# Downstream CMake2 compatibility
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

ament_export_dependencies(
    ecl_config
    ecl_errors
)
ament_package()

=== include/ecl/CMakeLists.txt ===
##############################################################################
# Subdirectories
##############################################################################

add_subdirectory(time_lite)

##############################################################################
# Files
##############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)

install(FILES ${HEADERS} DESTINATION include/ecl)

=== src/examples/CMakeLists.txt ===
##############################################################################
# Files
##############################################################################

add_executable(demo_time_functions time_functions.cpp)
target_link_libraries(demo_time_functions ${PROJECT_NAME})
install(TARGETS demo_time_functions RUNTIME DESTINATION lib/${PROJECT_NAME})

=== src/lib/CMakeLists.txt ===
##############################################################################
# Files
##############################################################################

file(GLOB SOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.cpp)

###############################################################################
# Targets
###############################################################################

add_library(${PROJECT_NAME} ${SOURCES})
target_include_directories(
  ${PROJECT_NAME}
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    $<INSTALL_INTERFACE:include>
)
target_link_libraries(${PROJECT_NAME}
  PUBLIC
    ecl_config::ecl_config
    ecl_errors::ecl_errors
    ${ECL_PLATFORM_TIME_LIBRARIES}
)
set_target_properties(${PROJECT_NAME}
  PROPERTIES
    SOVERSION ${${PROJECT_NAME}_VERSION}
    VERSION ${${PROJECT_NAME}_VERSION}
)

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
   RUNTIME DESTINATION bin
   ARCHIVE DESTINATION lib
   LIBRARY DESTINATION lib
)

=== include/ecl/time_lite/CMakeLists.txt ===
###############################################################################
# Generate Header
###############################################################################
##############################################################################
# Initialisation
##############################################################################


##############################################################################
# Symbol Generation (for ecl/time_lite/config.hpp
##############################################################################

# see ecl_detect_posix and ecl_detect_timers in
# ecl_build/cmake/modules/ecl_platform_detection.cmake

if(ECL_POSIX_HAS_CLOCK_GETTIME)
  set(ECL_PRIVATE_HAS_CLOCK_GETTIME 1)
endif()
if(ECL_POSIX_HAS_CLOCK_NANOSLEEP)
  set(ECL_PRIVATE_HAS_CLOCK_NANOSLEEP 1)
endif()
if(ECL_POSIX_HAS_CLOCK_MONOTONIC)
  set(ECL_HAS_CLOCK_MONOTONIC 1)
endif()
if(ECL_POSIX_HAS_CPUTIME)
  set(ECL_HAS_CPUTIME 1)
endif()
if(ECL_PLATFORM_HAS_MACH_TIMERS)
  set(ECL_HAS_MACH_TIMERS 1)
endif()
if(ECL_PLATFORM_HAS_WIN_TIMERS)
  set(ECL_HAS_WIN_TIMERS 1)
endif()
if(ECL_PLATFORM_HAS_RT_TIMERS)
  set(ECL_HAS_RT_TIMERS 1)
endif()
if(ECL_PLATFORM_HAS_POSIX_TIMERS)
  set(ECL_HAS_POSIX_TIMERS 1)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/config.hpp)

##############################################################################
# Files
##############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)

install(FILES ${HEADERS} DESTINATION include/ecl/time_lite)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/config.hpp DESTINATION include/ecl/time_lite)

=== debian/changelog ===
ros-iron-ecl-time-lite (1.2.0-4jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Daniel Stonier <d.stonier@gmail.com>  Thu, 20 Apr 2023 04:32:05 -0000

ros-iron-ecl-time-lite (1.0.3-4jammy) jammy; urgency=high

  * pedantic error message fixes for const error string methods on clang/macosx

 -- Daniel Stonier <d.stonier@gmail.com>  Mon, 20 Aug 2018 16:00:00 -0000

ros-iron-ecl-time-lite (0.61.1-4jammy) jammy; urgency=high

  * support get_date_string on macosx.

 -- Daniel Stonier <d.stonier@gmail.com>  Sat, 25 Jul 2015 16:00:00 -0000

ros-iron-ecl-time-lite (0.61.0-4jammy) jammy; urgency=high

  * unique get date string function for unique filename creation.
  * optional flag for getting real time instead of monolithic posix time (this syncs with ROS)

 -- Daniel Stonier <d.stonier@gmail.com>  Thu, 11 Sep 2014 16:00:00 -0000

ros-iron-ecl-time-lite (0.60.1-4jammy) jammy; urgency=high

  * update to catkin's CFG_EXTRAS for easy to find cmake modules.
  * Contributors: Daniel Stonier

 -- Daniel Stonier <d.stonier@gmail.com>  Tue, 28 Jan 2014 16:00:00 -0000

=== debian/control ===
Source: ros-iron-ecl-time-lite
Section: misc
Priority: optional
Maintainer: Daniel Stonier <d.stonier@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-iron-ament-cmake-ros, ros-iron-ecl-build, ros-iron-ecl-config, ros-iron-ecl-errors, ros-iron-ecl-license, ros-iron-ros-workspace
Homepage: http://wiki.ros.org/ecl_time_lite
Standards-Version: 3.9.2

Package: ros-iron-ecl-time-lite
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-ecl-build, ros-iron-ecl-config, ros-iron-ecl-errors, ros-iron-ecl-license, ros-iron-ros-workspace
Description: Provides a portable set of time functions that are especially useful for porting other code or being wrapped by higher level c++ classes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-ecl-time-lite//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
